︠fc2aebd0-6218-4de6-87b3-92c44ab4c57c︠
def exponent(p,power,E):
    #Assumes p does not divide |E(F_p)|.
    #For the curve E:y^2 = x^3 + 80, this gives the correct result because for all primes p, p does not divide |E(F_p)|.
    Ep = E.reduction(p)
    exp = Ep.abelian_group().generator_orders()[0]
    return exp*p^(power-1) 
def is_strong_elliptic_Carmichael_number(E,N):
    if gcd(E.discriminant(),N) > 1:
        return false
    factorization = list(factor(N))
    if len(factorization) <= 1: return false
    cond = E.conductor()
    aN = 1
    prime_coefficients = {}
    #compute ap, aN
    for prime, power in factorization:
        listy = [1, prime+1-E.Np(prime)]
        char = 1
        if mod(cond,prime) == 0:
            char = 0
        for j in range(2,power+1):
            listy.append(listy[1]*listy[j-1]-char*prime*listy[j-2])
        aN = aN*listy[-1]
        prime_coefficients[prime] = listy[1]
    t = N+1-aN
    while mod(t,2) != 1:
        t/=2
    #check exponent of group E(Z/p^ord_p(N)Z) divides t.
    for prime, power in factorization:
        exp = exponent(prime,power,E)
        if mod(t, exp) != 0:
            return false
    return true

A,B = 0,80
E = EllipticCurve([A,B])
count = 1
N = 1
while true:
    if is_strong_elliptic_Carmichael_number(E,N):
        print count,N
        count+=1
    N+=1
︡b00c45df-3a21-473f-a83e-f8f0ad6a6380︡{"stdout":"1"}︡{"stdout":" 7783\n2"}︡{"stdout":" 327781\n3"}︡{"stdout":" 416521\n4"}︡{"stdout":" 991681\n5"}︡{"stdout":" 3401341\n6"}︡{"stdout":" 4584187\n7"}︡{"stdout":" 5234089\n8"}︡{"stdout":" 5325883\n9"}︡{"stdout":" 991681\n5"}︡{"stdout":" 3401341\n6"}︡{"stdout":" 4584187\n7"}︡{"stdout":" 5234089\n8"}︡{"stdout":" 5325883\n9"}










